unit UnitFrameProgramEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Buttons, StdCtrls, ExtCtrls;

type
  TFrameProgramEdit = class(TFrame)
    txtProgram: TLabeledEdit;
    txtParam: TLabeledEdit;
    SpeedButton1: TSpeedButton;
    pmLocations: TPopupMenu;
    Desktop1: TMenuItem;
    StartMenu1: TMenuItem;
    StartMenuAllUsers1: TMenuItem;
    Documents1: TMenuItem;
    odLocations: TOpenDialog;
    bSet: TButton;
    bCancel: TButton;
    procedure Desktop1Click(Sender: TObject);
    procedure StartMenu1Click(Sender: TObject);
    procedure StartMenuAllUsers1Click(Sender: TObject);
    procedure Documents1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure txtProgramChange(Sender: TObject);
  private
    { Private declarations }
    procedure OpenDialog;
  public
    { Public declarations }
    function GetProgram(var prog : string; var param : string) : boolean;
    procedure SetProgram(initdata : string);
  end;

var
  FrameProgramEdit: TFrameProgramEdit;

implementation

uses UnitSpecialPaths, UnitMisc, UnitToken;

{$R *.dfm}

procedure TFrameProgramEdit.Desktop1Click(Sender: TObject);
begin
    odLocations.InitialDir :=  SpecialPaths.GetDesktop;
    OpenDialog;
end;

procedure TFrameProgramEdit.Documents1Click(Sender: TObject);
begin
    odLocations.InitialDir := SpecialPaths.GetMyDocs;
    OpenDialog;
end;

function TFrameProgramEdit.GetProgram(var prog, param: string): boolean;
begin
    //if ThreadAttach(GetForegroundWindow)  then begin
        //self.ShowModal;
        //result := self.ModalResult = mrOK;
        //if result then begin
            prog := txtProgram.Text;
            param := txtParam.Text;
        //end;
        //ThreadDetach;
    //end;

end;

procedure TFrameProgramEdit.OpenDialog;
begin
    odLocations.FileName := '';
    if odLocations.Execute then begin
        txtProgram.text := odLocations.FileName; 
    end;
end;

procedure TFrameProgramEdit.SetProgram(initdata: string);
begin
    txtProgram.Text := TokenString(initdata, '|');
    txtParam.text := initdata;
end;

procedure TFrameProgramEdit.SpeedButton1Click(Sender: TObject);
begin
    pmLocations.Popup( mouse.CursorPos.x - 30, mouse.cursorpos.y + 20);    
end;

procedure TFrameProgramEdit.StartMenu1Click(Sender: TObject);
begin
    odLocations.InitialDir := SpecialPaths.GetStartMenu;
    OpenDialog;
end;

procedure TFrameProgramEdit.StartMenuAllUsers1Click(Sender: TObject);
begin
    odLocations.InitialDir := SpecialPaths.GetStartMenuAllUsers;
    OpenDialog; 
end;

procedure TFrameProgramEdit.txtProgramChange(Sender: TObject);
var str : array [0.. MAX_PATH] of Char;
begin
    bset.enabled := FileExists(txtProgram.Text);
    if not bset.enabled then begin
        bset.Enabled := FileExists(ExpandVars(txtProgram.text));
    end;
    
    
end;

end.
